(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../../../../Utils/Utils.js", "./ClickEvent.js", "./DivEvent.js", "./HoverEvent.js", "./ResizeEvent.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Events = void 0;
    const Utils_js_1 = require("../../../../Utils/Utils.js");
    const ClickEvent_js_1 = require("./ClickEvent.js");
    const DivEvent_js_1 = require("./DivEvent.js");
    const HoverEvent_js_1 = require("./HoverEvent.js");
    const ResizeEvent_js_1 = require("./ResizeEvent.js");
    class Events {
        constructor() {
            this.onClick = new ClickEvent_js_1.ClickEvent();
            this.onDiv = new DivEvent_js_1.DivEvent();
            this.onHover = new HoverEvent_js_1.HoverEvent();
            this.resize = new ResizeEvent_js_1.ResizeEvent();
        }
        load(data) {
            if (!data) {
                return;
            }
            this.onClick.load(data.onClick);
            const onDiv = data.onDiv;
            if (onDiv !== undefined) {
                this.onDiv = (0, Utils_js_1.executeOnSingleOrMultiple)(onDiv, (t) => {
                    const tmp = new DivEvent_js_1.DivEvent();
                    tmp.load(t);
                    return tmp;
                });
            }
            this.onHover.load(data.onHover);
            if ((0, Utils_js_1.isBoolean)(data.resize)) {
                this.resize.enable = data.resize;
            }
            else {
                this.resize.load(data.resize);
            }
        }
    }
    exports.Events = Events;
});
